class InsertionSort extends SortingAlgorithm {
  public void sort() { 
    marker("sorted", #0000FF);
    marker("next", #FFFF00);
    
    for (int i = 1; i < this.data.length; i++) {
      mark("sorted", i);
      unmark("next");

      for (int j = 0; j < i; j++) {
        mark("next", j);
        
        if (compare(j, i) > 0) {
          swap(j, i);
        }
      }
    }
  }
}
