class QuickSort extends SortingAlgorithm {
  void sort() {
    marker("pivot", #FFFF00);
    marker("start", #FF00FF);
    marker("end", #00FFFF);
    marker("i", #FFFFFF);
    quick(0, this.data.length - 1);
  }
  
  void quick(int start, int end) {
    if (start < end) {
      mark("start", start);
      mark("end", end);
      
      int pivot = partition(start, end);
      
      mark("pivot", pivot);
      
      quick(start, pivot - 1);  
      quick(pivot + 1, end);  
    }  
  }
  
  int partition(int start, int end)  {  
    int pivot = end;
    int i = start - 1;  
    mark("i", i);
    
    for (int j = start; j <= end - 1; j++) {  
      if (compare(j, pivot) < 0) {  
          i++;    
          mark("i", i);
          swap(i, j);  
      }
    }
    
    swap(i + 1, end);
    
    return i + 1;  
  }
}
