class SelectionSort extends SortingAlgorithm {
  public void sort() { 
    marker("sorted", #0000FF);
    marker("min", #FFFF00);
    
    for (int i = 0; i < this.data.length - 1; i++) {
      mark("sorted", i);
      unmark("min");

      int minIdx = i;

      for (int j = i + 1; j < this.data.length; j++) {
        if (this.compare(j, minIdx) < 0) {
          minIdx = j;      
          mark("min", minIdx);
        }
      }

      swap(i, minIdx);
    }
  }
}
